"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getPeer = getPeer;
exports.addTurnUrl = addTurnUrl;

var _spPeer = require("./sp-peer");

var _spPeer2 = _interopRequireDefault(_spPeer);

var _spPeerConnection = require("./sp-peer-connection");

var _spPeerConnection2 = _interopRequireDefault(_spPeerConnection);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * This is the external interfaces that folks use to set up WebRTCPeerConnections.
 */

var peers = {};

/**
 * Goes and talks to a peer. If we have a stream for them, resolves right away. Otherwise resolves
 * to a peer once we have one.
 */
function getPeer(userId) {
  if (!peers[userId]) {
    peers[userId] = new _spPeer2.default(userId);
  }

  return peers[userId];
}

/**
 * We learned about an new TURN url available to us! How splendid. Add it to our list that we'll
 * use to try and connect to people.
 *
 * Streamplace doesn't fuck with STUN URLs. We don't have to. TURN takes case of it.
 */
function addTurnUrl(turnUrl) {
  _spPeerConnection2.default.addTurnUrl(turnUrl);
}