"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _spClient = require("sp-client");

var _spClient2 = _interopRequireDefault(_spClient);

var _wolfy87Eventemitter = require("wolfy87-eventemitter");

var _wolfy87Eventemitter2 = _interopRequireDefault(_wolfy87Eventemitter);

var _spPeerStream = require("./sp-peer-stream");

var _spPeerConnection = require("./sp-peer-connection");

var _spPeerConnection2 = _interopRequireDefault(_spPeerConnection);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var SPPeer = function (_EE) {
  _inherits(SPPeer, _EE);

  function SPPeer(userId) {
    _classCallCheck(this, SPPeer);

    var _this = _possibleConstructorReturn(this, (SPPeer.__proto__ || Object.getPrototypeOf(SPPeer)).call(this));

    _this.userId = userId;
    if (!_spClient2.default.user) {
      throw new Error("Cannot create peer connection without being logged in!");
    }
    _this.on("stream", function (stream) {
      _this.stream = stream;
    });
    if (userId === _spClient2.default.user.id) {
      _this.startLocalStream();
    } else {
      _this.startRemoteStream();
    }
    return _this;
  }

  /**
   * This is a peer connection to the current user, cool. Set up a local stream.
   */


  _createClass(SPPeer, [{
    key: "startLocalStream",
    value: function startLocalStream() {
      var _this2 = this;

      return navigator.mediaDevices.getUserMedia({
        audio: true,
        video: {
          width: { min: 1280 },
          height: { min: 720 }
        }
      }).then(function (stream) {
        _this2.emit("stream", stream);
      });
    }

    /**
     * Open up a PeerConnection to the other person, plz
     */

  }, {
    key: "startRemoteStream",
    value: function startRemoteStream() {
      var _this3 = this;

      var localPeer = (0, _spPeerStream.getPeer)(_spClient2.default.user.id);
      localPeer.getStream().then(function (stream) {
        _this3.connection = new _spPeerConnection2.default({
          targetUserId: _this3.userId,
          stream: stream
        });
        _this3.connection.getStream().then(function (stream) {
          _this3.emit("stream", stream);
        });
        _this3.connection.on("disconnected", function () {
          _this3.stream = null;
          // TODO: add throttling
          _this3.startRemoteStream();
        });
      });
    }

    /**
     * Get an active stream if we have one. Otherwise resolve one when we do.
     */

  }, {
    key: "getStream",
    value: function getStream() {
      var _this4 = this;

      if (this.stream) {
        return Promise.resolve(this.stream);
      } else {
        return new Promise(function (resolve, reject) {
          _this4.once("stream", function (stream) {
            resolve(stream);
          });
        });
      }
    }

    /**
     * Like "on", but also runs the callback immediately if we already have the property in question.
     */

  }, {
    key: "retrieve",
    value: function retrieve(prop, cb) {
      var _this5 = this;

      if (this[prop]) {
        setTimeout(function () {
          cb(_this5[prop]);
        }, 0);
      }
      this.on(prop, cb);
    }
  }]);

  return SPPeer;
}(_wolfy87Eventemitter2.default);

exports.default = SPPeer;